function delPlayList(key) {

    post("DELETE_PLAYLIST", key)
    mainView.innerHTML = WelcomeContent
    playlistSelected = null
    playlistValue = null

}


function playPlayList(key) {

    post("PLAY_PLAYLIST", key)
 

}

function sendPlayList(key) {

    const playlist_popup = document.getElementById("playlist_popup")

    if(playlist_popup) {

        get("USER_LIST").then(resp => {

            const userToPush = new Array()

            for(var user of resp) {

                userToPush.push(`<div id='${resp.indexOf(user)}' class="popup_line"><img src="${user.picture}"><div style="display: flex; flex-direction: column; justify-content: start; text-align: start;"><p class="INDEX_gbname">${user.global_name}</p><p class="INDEX_usrname">${user.username}</p></div></div>`)

            }

            playlist_popup.innerHTML = userToPush.join("")
            playlist_popup.style.width = '170px'
            playlist_popup.style.top = (yMousePos - 30) + "px"
            playlist_popup.style.left = (xMousePos - 165) + "px"
            playlist_popup.style.overflowY = "auto";
            playlist_popup.style.height = "250px"
            playlist_popup.classList.remove("invisible")


            playlist_popup.addEventListener("mouseleave", () => {
            
                playlist_popup.classList.add("invisible")

            })

            for(var user of resp) {

                const userElement = document.getElementById(resp.indexOf(user))

                userElement.addEventListener("click", () => {

                    playlist_popup.classList.add("invisible")
                    post("SEND_PLAYLIST", {key: key, dest: resp[userElement.id].id})
                })
            }
    
            //post("SEND_PLAYLIST", key, user.id)
    
        })
    }

    
 
}


function loadPlaylist(key, value) {

    userLocation = "playlist"   

    var playlistToPush = new Array()
    var playlist_songs = new Array()

    playlistSelected = key
    playlistValue = value

    for(var title of value) {

            var PFormatduration = getTimeCode(title.duration)

            var thumbnail = title.thumbnail
    
            if(!thumbnail) {

                thumbnail = "/images/black-image.svg"
                        
            }

            if(title.duration == 9223372036854776000) {

                PFormatduration = "<i style='color: red;' class='fa-solid fa-circle'></i> LIVE"
            }

        playlist_songs.push('<div class="search_song"> <img class="search_thumbnail" src="' + thumbnail + '"><div class="search_titleSong"> <p class="search_title">' + title.title + '</p></div> <p>' + title.author + '</p><p>' + PFormatduration + '</p> <div class="search_buttons"><button id="' + value.indexOf(title) +  '_padd" class="search_add"><i class="fa fa-plus"></i></button><button id="' + value.indexOf(title) +  '_pplay" class="search_lmore"><i class="fa fa-play"></i></button><button id="' + value.indexOf(title) +  '_pdelete" style="font-size: 20px;" class="list_delete"><i class="fa fa-trash"></i></button></div></div>')

    }



    playlistToPush.push(`<div class="INDEX_userPopup invisible" id="playlist_popup"></div>`)
    playlistToPush.push('<div class="apPres"><div class="apTitle"><img class="apTile" src="/images/playlist-tile.svg"><p class="apName">' + key + '</p></div><div class="apButtons"><button onclick="playPlayList(\''+ key +'\')" id="'+ key +'_playlistplay" class="primary"><i class="fas fa-play"></i><button onclick="sendPlayList(\''+ key +'\')" id="sendplaylist" class="list_upSong"><i class="fas fa-paper-plane"></i></button></button><button onclick="delPlayList(\''+ key +'\')" id="playlistdelete" class="list_delete"><i class="fas fa-trash"></i></button></div></div><hr>' + playlist_songs.join(""))
    
    if(playlistToPush.join("") == "") {

        mainView.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
    
    } else {

        mainView.innerHTML = playlistToPush.join("")

        
    }

    for(var title of value) {

        const add_to = document.getElementById(value.indexOf(title) + "_padd")
        const playNow = document.getElementById(value.indexOf(title) + "_pplay")
        const deleteBtn = document.getElementById(value.indexOf(title) + "_pdelete")

        add_to.addEventListener("click", () => {

            post("ADD_SONG", value[add_to.id.replace("_padd", "")])
        })

        playNow.addEventListener("click", () => {
     
            post("ADD_SONG_NOW", value[add_to.id.replace("_padd", "")])

        })

        deleteBtn.addEventListener("click", () => {

            deleteJustBefore = true
            post("DELETE_SONG_TO_PLAYLIST", {data: key, song: value[add_to.id.replace("_padd", "")]})
            
        })

    
    }

}

function fp_play_playlist(key) {
    
    post("FP_PLAY_PLAYLIST", key)
}

socket.on("DO_UPDATE_PLAYLIST", () => {

    get("PLAYLIST")
})

get("PLAYLIST")


socket.on("ANSWER/GET/PLAYLIST", (data) => {
    var contentToPush = new Array()
    var selectionData = new Array()

    contentToPush.push(`<p>Mes Playlists</p>`)
    contentToPush.push('<div id="createPlaylist" class="playlist_div"><i class="fa-solid fa-plus"></i> Créer une playlist</div>')


    for (const [key, value] of Object.entries(data)) {

        contentToPush.push('<div id="' + key + '_playlist" class="playlist_div checker"><img class="tile" src="/images/playlist-tile.svg"><p>' + key + '</p></div>')
        selectionData.push('<option style="color: black;">' + key +  '</option>')
    }
    

    

    if(contentToPush.join("") == "") {
        
        playlistContent.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
    
    } else {

        playlistContent.innerHTML = contentToPush.join("")
        playlistAvailable = selectionData
    }

    if(playlistSelected && deleteJustBefore || playlistSelected && userLocation == "playlist") {
        deleteJustBefore = null
        loadPlaylist(playlistSelected, data[playlistSelected])   
    }

    for (const [key, value] of Object.entries(data)) {

        const playlist_selector = document.getElementById(key + '_playlist')

        playlist_selector.addEventListener("click", () => {
            
            loadPlaylist(key, value) 
            userLocation = "playlist"         

        })
    }

    const buttons = document.querySelectorAll(".checker");

    buttons.forEach(button => {
        button.addEventListener("click", function () {
            buttons.forEach(btn => {
                if (btn === button) {
                    btn.style.color = "white";
                } else {
                    btn.style.color = "";
                }
            });
        });
    });
    
    
    const addPlaylist = document.getElementById("createPlaylist")
    const addPlaylist_dialog = document.getElementById("createPlaylist_dialog")
    const addPlaylist_close = document.getElementById("createPlaylist_close")
    const apText = document.getElementById("apText")
    const apInfo = document.getElementById("apInfo")
    const apCreate = document.getElementById("apCreate")


    addPlaylist_close.addEventListener("click", () => {
        apInfo.innerHTML = ""
        addPlaylist_dialog.close()
    })

    addPlaylist.addEventListener("click", () => {
        
        apText.innerHTML = ""
        addPlaylist_dialog.showModal()
    })

    apCreate.addEventListener("click", () => {
        apInfo.innerHTML = ""
        var wrongName = true

        const refusedChar = ['\\','/' ,':' ,'*','?' ,'"','<','>','|']

            for(var char of refusedChar) {

                if(apText.value.includes(char)) {
                    wrongName = false

                } 
            }

        if(apText.value != "" && apText.value != " " && wrongName) {

            addPlaylist_dialog.close()
            post("CREATE_PLAYLIST", apText.value)
        } else {

            apInfo.innerHTML = "<span style='red'>Le nom n'est pas valide !</style>"
        }
        
        
    })

  
    
    console.log(data)
})



// Current Playlist and Song 

const cPlaylistManager = document.getElementById("current_playlistManager")
const cplaylistManager_close = document.getElementById("current_playlistManager_close")
const cplaylistSelection = document.getElementById("current_playlistSelection")
const cplaylist_add_music = document.getElementById("current_playlist_add_music")
const cplaylist_add_img = document.getElementById("current_playlist_add_img")
const cplaylistAddSong = document.getElementById("current_playlistAddSong")

takeCurrent.addEventListener("click", () => {

    if(currentSong != null) {

        var thumbnail = currentSong.thumbnail

        if(!thumbnail) {

            thumbnail = "/images/black-image.svg"
        }

        cPlaylistManager.showModal()
        cplaylist_add_music.innerHTML = currentSong.title
        cplaylist_add_img.src = thumbnail
        cplaylistSelection.innerHTML = playlistAvailable

    }

})

cplaylistManager_close.addEventListener("click", () => {

    cPlaylistManager.close()
})

cplaylistAddSong.addEventListener("click", () => {

                        
    cPlaylistManager.close()
    post("ADD_SONG_TO_PLAYLIST", {data: cplaylistSelection.value , song: currentSong} )
    
   

})